/**
 * Implementation of CheckedAccount wihtout inheritance
 */
public class AdaptedCheckedAccount implements BankAccount
{
    private int minBalance;
    private Account account;
    
    public AdaptedCheckedAccount(Account acc, int minBalance) {
        account = acc;
        this.minBalance = minBalance;
    }
    
    public double getMinBalance() {
        return minBalance;
    }
    
    public double getBalance() {
        return account.getBalance();
    }
    
    public double add(double amount) {
        return account.add(amount);
    }
    
    public double withdraw(double amount) {
        if (getBalance() - amount >=  minBalance) {
            account.withdraw(amount);
        }
        return getBalance();
    }  
}
